# Class CustomAttribute<T extends CustomAttribute<T>>

java.lang.Object
java.lang.classfile.CustomAttribute<T>

Type Parameters:
  `T` - the custom attribute type

All Implemented Interfaces:
  `Attribute<T>, ClassElement, ClassFileElement, CodeElement, FieldElement, MethodElement`

public abstract non-sealed class CustomAttribute<T extends CustomAttribute<T>> extends Object implements Attribute<T>, CodeElement, ClassElement, MethodElement, FieldElement
Models a user-defined attribute in a `class` file. API models for user-defined attributes should extend this class. A user-defined attribute should also have an `AttributeMapper` defined, which will be returned by `attributeMapper()`, and registered to the `ClassFile.AttributeMapperOption` so the user-defined attributes can be read.

Accessor methods on user-defined attributes read from `class` files may throw `IllegalArgumentException` if the attribute model is lazily evaluated, and the evaluation encounters malformed `class` file format for the attribute.

Since:
  24
See Also:
  - `java.lang.classfile.attribute`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CustomAttribute(AttributeMapper<T> mapper)`
  Constructor for subclasses to call.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final AttributeMapper<T>`
  `attributeMapper()`
  Returns the `AttributeMapper` associated with this attribute.
  `Utf8Entry`
  `attributeName()`
  Returns the name of the attribute.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CustomAttribute

    protected CustomAttribute(AttributeMapper<T> mapper)
    Constructor for subclasses to call.
    Parameters:
      `mapper` - the attribute mapper

- ## Method Details

  - ### attributeMapper

    public final AttributeMapper<T> attributeMapper()
    Description copied from interface: `Attribute`
    Returns the `AttributeMapper` associated with this attribute.
    Specified by:
      `attributeMapper` in interface `Attribute<T extends CustomAttribute<T>>`
    Returns:
      the `AttributeMapper` associated with this attribute

  - ### attributeName

    public Utf8Entry attributeName()
    Returns the name of the attribute. The string value of the name is equivalent to the value of `attributeMapper().name()`.

    If this attribute is read from a `class` file, this method returns the `Utf8Entry` indicating the attribute name in the `class` file.

    Specified by:
      `attributeName` in interface `Attribute<T extends CustomAttribute<T>>`
    Implementation Requirements:
      The default implementation returns a `Utf8Entry` suitable for writing only, which may be unbound. Subclasses representing attributes read from `class` files must override this method.
    Returns:
      the name of the attribute
    See Also:
      - `AttributeMapper.readAttribute(AttributedElement, ClassReader, int)`